jQuery(function ($) {
  //  背景切替情報を格納する変数
  var bgmap = [];
  var firstbg = $('#firstbg').attr('data-firstbg');
  var firstfilter = $('#firstbg').attr('data-filter');
  var lastsrc = '';
  var lastfilter = '';
  var cursrc = '';
  var curfilter = '';
  var nextsrc = '';
  var mode = 'fadein';

  //  ページ全体の高さを格納する変数
  var docheight = $(document).height();
  //  ウインドウの高さを格納する変数
  var winheight = $(window).height();
  //  ウインドウ上端のページ内位置を格納する変数
  var wintop = $(window).scrollTop();


  function removefadeout() {
    //        bgblurnext,bgnext, bgfilternextにfadeoutクラスがついている場合は除去
    if ($('#bgblurnext').hasClass('fadeout')) {
      $('#bgblurnext').removeClass('fadeout');
    }
    if ($('#bgnext').hasClass('fadeout')) {
      $('#bgnext').removeClass('fadeout');
    }
    if ($('#bgfilternext').hasClass('fadeout')) {
      $('#bgfilternext').removeClass('fadeout');
    }
  }




  //  基準位置を取得して必要に応じて背景を変更する関数
  function dobgchange() {
    //ウインドウ中央の位置を取得
    var wind = $(window).scrollTop() + $(window).height() / 2;

    //    背景配列の長さを取得
    var bglistlen = bgmap.length;

    //    途中切り替えがない(配列長1)なら初期背景を設定して抜ける
    if (bglistlen <= 1) {
      //      既に設定済の場合は何もしない。フィルター導入後、フィルター有無も判定して処理すること
      cursrc = $('#bgcur img').attr('src');
      if (cursrc !== firstbg) {
        $('#bgblur img').attr('src', firstbg);
        $('#bgblur').attr('class', firstfilter);
        $('#bgcur img').attr('src', firstbg);
        $('#bgcur').attr('class', firstfilter);
      }
      return;
    }

    //  配列の長さ回数ループする
    for (var i = 0; i < bglistlen; i++) {

      var data1 = bgmap[i];
      var point1 = data1[0];
      var newbg = data1[1];
      var mode = data1[2];
      var newfilter = data1[3];

      //      もし最後の回なら背景処理して関数終了させる
      if (i == (bglistlen - 1)) {

        //        背景とフィルタが変更不要ならただ抜ける
        cursrc = $('#bgcur img').attr('src');
        curfilter = lastfilter;
        if ((cursrc == newbg) && (curfilter == newfilter)) {
          return;
        }

        //bgblurnext,bgnext, bgfilternextにfadeoutクラスがついている場合は除去
        removefadeout();

        //   bgblurnext、bgnext、bgfilternext内の画像に変更前の画像を入れて表示させる
        $('#bgblurnext img').attr('src', lastsrc);
        $('#bgnext img').attr('src', lastsrc);
        //          フィルタ作ったら$('#bgfilternext img')に対しても適切な処理をする
        $('#bgfilternext').addClass('ready');
        $('#bgnext').addClass('ready');
        $('#bgblurnext').addClass('ready');

        //        bgcur、bgblur,bgfilter内の画像に変更後の画像を入れる
        $('#bgblur img').attr('src', newbg);
        $('#bgcur img').attr('src', newbg);
        //          #bgfilter imgについてもフィルターを作ったらここで処理する


        //bgblurnext, bgnext,bgfilternextからreadyを削除してフェードアウトさせる

        $('#bgfilternext').addClass('fadeout');
        $('#bgnext').addClass('fadeout');
        $('#bgblurnext').addClass('fadeout');
        $('#bgfilternext').removeClass('ready');
        $('#bgnext').removeClass('ready');
        $('#bgblurnext').removeClass('ready');

        //        lastfilterとlastsrcを更新して抜ける
        lastfilter = newfilter;
        lastsrc = newbg;

        //          0.5秒後にfadeoutクラスを除く
        setTimeout(function () {
          removefadeout();
        }, 500);
        return;

      } else {
        //  最終以外なら、次のデータを読み込む
        var data2 = bgmap[i + 1];
        var point2 = data2[0];

        // point1からpoint2の間の場合のみ実行
        if ((wind >= point1) && (wind < point2)) {

          //読込時、リロード時、lastsrcがnullのはずなので、画面がトップならばエフェクトなしで背景設定して情報更新して抜ける

          if (!lastsrc) {
            $('#bgblur img').attr('src', firstbg);
            $('#bgblur').attr('class', firstfilter);
            $('#bgcur img').attr('src', firstbg);
            $('#bgcur').attr('class', firstfilter);
            lastsrc = firstbg;
            lastfilter = firstfilter;
            return;
          }

          //          背景とフィルタの更新が必要ない場合はただ抜ける
          cursrc = $('#bgcur img').attr('src');
          curfilter = lastfilter;
          if ((cursrc == newbg) && (curfilter == newfilter)) {
            return;
          }

          //   bgblurnext,bgnext, bgfilternextにfadeoutクラスがついている場合は除去
          removefadeout();

          //   bgblurnext、bgnext、bgfilternext内の画像に変更前の画像を入れて表示させる
          $('#bgblurnext img').attr('src', lastsrc);
          $('#bgnext img').attr('src', lastsrc);
          //          フィルタ作ったら$('#bgfilternext img')に対しても何か処理する
          $('#bgfilternext').addClass('ready');
          $('#bgnext').addClass('ready');
          $('#bgblurnext').addClass('ready');

          //        bgcur、bgblur,bgfilter内の画像に変更後の画像を入れる
          $('#bgblur img').attr('src', newbg);
          $('#bgcur img').attr('src', newbg);
          //          #bgfilter imgについてもフィルターを作ったらここで処理する


          //bgblurnext, bgnext,bgfilternextからreadyを削除してフェードアウトさせる

          $('#bgfilternext').addClass('fadeout');
          $('#bgnext').addClass('fadeout');
          $('#bgblurnext').addClass('fadeout');
          $('#bgfilternext').removeClass('ready');
          $('#bgnext').removeClass('ready');
          $('#bgblurnext').removeClass('ready');

          //          0.5秒後にfadeoutクラスを除く
          setTimeout(function () {
            removefadeout();
          }, 500);

          //        lastfilterとlastsrcを更新して抜ける
          lastfilter = newfilter;
          lastsrc = newbg;
          return;

          return;
        }
      }



    }


  }

  //  背景切替ブロックから配列に情報格納し、背景更新も呼び出す関数
  function resetbgmap() {
    //    現在のbgmapを空にする
    bgmap.length = 0;
    //    初期値を格納する
    bgmap.push([0, firstbg, mode, firstfilter]);

    //背景切替ブロックの情報を取得して格納
    $('.bgchanger').each(function () {
      //    bgchangerが上から何ピクセルの位置にあるか取得
      var loc = Math.round($(this).offset().top);
      var bgpath = $(this).attr('data-bg');
      var bgmode = $(this).attr('data-mode');
      var bgfilter = $(this).attr('data-filter');
      var temparray = [loc, bgpath, bgmode, bgfilter];
      bgmap.push(temparray);
    });

    dobgchange();
  }

  //  ページ読み込み時、リサイズ時に背景切替ブロックの情報読み込み
  $(window).on('load resize', function () {
    resetbgmap();
    //    各種高さも再取得
    docheight = $(document).height();
    winheight = $(window).height();
    wintop = $(window).scrollTop();
    //    ヘッダとフッタについても確認
    headercontrol();
    footercontrol();
  });

  //    スクロール時のヘッダ処理
  function headercontrol() {

    //    上から2画面以内の位置なら
    if (wintop <= 2 * winheight) {
      //    slideoutがついていたら外す
      if ($('header').hasClass('slideout')) {
        $('header').removeClass('slideout');
      }
      //slideinが付いていれば何もしないで抜ける
      if ($('header').hasClass('slidein')) {
        return;
      }
      //    slideinをつける
      $('header').addClass('slidein');
    } else {
      //2画面以上スクロールしていたら
      //    slideinがなければ何もしないで抜ける
      if (!$('header').hasClass('slidein')) {
        return;
      }
      //  slideoutをつけてslideinを削除する。
      $('header').addClass('slideout');
      $('header').removeClass('slidein');
      //          0.5秒後にslideoutを除く
      setTimeout(function () {
        $('header').removeClass('slideout');
      }, 500);
    }
  }


  //    スクロール時のフッタ処理
  function footercontrol() {
    //    下から1.2画面以内なら
    if (wintop >= docheight - 1.2 * winheight) {
      //    slideoutがついていたら消す
      if ($('footer').hasClass('slideout')) {
        $('footer').removeClass('slideout');
      }
      //    slideinがついているなら何もしないで抜ける
      if ($('footer').hasClass('slidein')) {
        return;
      }
      //    slideinをつける
      $('footer').addClass('slidein');
    } else {
      //slideinが無いなら何もしないで抜ける
      if (!$('footer').hasClass('slidein')) {
        return;
      }
      //    slideoutがついていたら一旦消す
      if ($('footer').hasClass('slideout')) {
        $('footer').removeClass('slideout');
      }
      //slideoutをつけてslideinを消す
      $('footer').addClass('slideout');
      $('footer').removeClass('slidein');
      //    0.5秒後にslideoutも消す
      setTimeout(function () {
        $('footer').removeClass('slideout');
      }, 500);
    }
  }


  //スクロール時に実行する処理
  $(window).on('scroll', function () {
    wintop = $(window).scrollTop();
    dobgchange();
    headercontrol();
    footercontrol();
  });


});
